/*
 * BookInfoItem.h
 *
 *  Created on: 20/ott/2010
 *      Author: Luca Gambetta <l.gambetta@bluenine.it>
 */

#ifndef BOOKINFOITEM_H_
#define BOOKINFOITEM_H_

#include <QString>
#include <QDateTime>

typedef struct BookInfoItem {
	explicit BookInfoItem(const QString &ASIN_ = QString(), const QString &isbn_ = QString(),
			const QString &author_ = QString(), const QString &title_ = QString(),
			const QString &publisher_ = QString(), const QDateTime &publication_date_ = QDateTime(),
			const QString &binding_ = QString(), int number_of_pages_ = 0,
			const QString &detail_page_URL_ = QString(), const QString& edition_ = QString(),
			const QString &store_ = QString()) : ASIN(ASIN_), ISBN(isbn_), author(author_),
			title(title_), publisher(publisher_), publication_date(publication_date_),
			binding(binding_), number_of_pages(number_of_pages_), detail_page_URL(detail_page_URL_),
			edition(edition_), store(store_){}


	QString ASIN;
	QString ISBN;
	QString author;
    QString title;
    QString publisher;
    QDateTime publication_date;

    QString binding;
    int number_of_pages;
    QString detail_page_URL;
    QString edition;

    QString store;


//	    <Edition>Unabridged</Edition>
//	    <EditorialReview_Content>Illus. in full color. The polka-dot leopard Spot from <i>Put Me in the Zoo</i> returns. "Spot changes from elephant to giraffe to mouse, trying to find a new identity, but discovers that every animal shape has its drawbacks. This intelligent, cheerful sequel, with its simple rhyming text, lives up to the reputation of its predecessor."--<i>Publishers Weekly.<C2><A0><C2><A0></i></EditorialReview_Content>
//	    <EditorialReview_Source>Book Description</EditorialReview_Source>


//	    <ProductGroup>Book</ProductGroup>

//	    <store>amazon.com</store>
} BookInfoItem;


#endif /* BOOKINFOITEM_H_ */
