#ifndef BOOKLISTMODEL_H
#define BOOKLISTMODEL_H

#include <QObject>
#include <QAbstractListModel>
#include <QModelIndex>

#include "BookListItem.h"

class BookListModel : public QAbstractListModel
{
    Q_OBJECT

public:
    explicit BookListModel(QObject *parent = 0) : QAbstractListModel(parent) { }

    explicit BookListModel(BookList &book_list_, QObject *parent = 0) : QAbstractListModel(parent),book_list(book_list_) {}
	int rowCount(const QModelIndex &parent = QModelIndex()) const;

	void sort(int column, Qt::SortOrder order = Qt::AscendingOrder );

	QVariant data(const QModelIndex &index, int role) const;
	QVariant headerData(int section, Qt::Orientation orientation,
							 int role = Qt::DisplayRole) const;

	BookList getBookList();
	void setBookList(BookList &lista);

private:
	// La lista coi feed
	BookList book_list;
};

#endif // BOOKLISTMODEL_H
