#include "bookmoocherdata.h"

#include <QtXml>
#include <QFile>
#include <QTextStream>

#include <QDebug>

bool BookMoocherData::is_initialized = false;
QHash<QString, QString> BookMoocherData::countries = QHash<QString,QString>();
QHash<QString, QString> BookMoocherData::genres = QHash<QString,QString>();

BookMoocherData::BookMoocherData()
{
}


const QHash<QString, QString> &BookMoocherData::getCountries() {
	BookMoocherData::initialize();
	return BookMoocherData::countries;
}

const QHash<QString, QString> &BookMoocherData::getGenres() {
	BookMoocherData::initialize();
	return BookMoocherData::genres;
}

bool BookMoocherData::initialize() {
	if (!BookMoocherData::is_initialized) {
		// ---- Inizializza le città
		// Apre il file di risorse
		QFile file(":/countries.csv");
		if (!file.open(QIODevice::ReadOnly)) {
			qDebug() << "Impossibile aprire il file di risorse countries.csv";
			return false;
		}

		// formato del file: CODICE maiuscolo di 2 lettere,(virgola)Descrizione(stringa)
		// es: IT,Italia
		QTextStream stream(&file);
		QString line;
		do {
			line = stream.readLine();
			if (line != NULL) {
				BookMoocherData::countries.insert(line.mid(0, 2),  line.mid(3));
			}
		} while(!stream.atEnd());

		file.close();

		// --- Inizializza i generi
		// Apre il file di risorse
		file.setFileName(":/genres.csv");
		if (!file.open(QIODevice::ReadOnly)) {
			qDebug() << "Impossibile aprire il file di risorse genres.csv";
			return false;
		}

		// formato del file: codicegenere,(virgola)Descrizione(stringa)
		// es: hor,Horror
		stream.setDevice(&file);
		int pos = 0;
		do {
			line = stream.readLine();
			if (line != NULL) {
				pos = line.indexOf(',');
				BookMoocherData::genres.insert(line.mid(0, pos), line.mid(pos + 1));
			}
		} while(!stream.atEnd());

		file.close();

		BookMoocherData::is_initialized = true;

		return true;
	}
	return false;
}

bool BookMoocherData::populateCountriesCombo(QComboBox *combobox) {
	BookMoocherData::initialize();
	QHash<QString, QString>::const_iterator i = countries.constBegin();
	while (i != countries.constEnd()) {
		combobox->addItem(i.value(), i.key() );
		++i;
	}
	combobox->model()->sort(0, Qt::AscendingOrder);

	return true;
}

bool BookMoocherData::populateGenresCombo(QComboBox *combobox) {
	BookMoocherData::initialize();
	QHash<QString, QString>::const_iterator i = genres.constBegin();
	while (i != genres.constEnd()) {
		combobox->addItem(i.value(), i.key() );
		++i;
	}
	combobox->model()->sort(0, Qt::AscendingOrder);

	return true;
}
