#ifndef DEFINES_H
#define DEFINES_H

/*
 Definizioni utili in più di un punto
 */

#define APP_VERSION "0.0.6"

// Parametro di configurazione: intervallo in minuti degli aggiornamenti
#define CFG_BOOK_INFO_FETCH_INTERVAL "book_info_fetch_interval"

// Vecchio parametro di configurazione, da rimuovere
#define CFG_OLD_RSS_FETCH_INTERVAL "rss_fetch_interval"

// Parametro di configurazione: lista di stringhe di due caratteri con le nazioni
#define CFG_COUNTRIES_LIST "countries_list"

// Parametro di configurazione: lista di stringhe coi generi
#define CFG_GENRES_LIST "genres_list"

// Parametro di configurazione: versione di BookMoocher
#define CFG_APP_VERSION "bm_version"

// Azione per il doppio click sulla lista dei libri
#define CFG_BOOK_LISTVIEW_DOUBLECLICK "book_listview_dblclk"
// Valori possibili:
#define CFG_BOOK_LISTVIEW_DOUBLECLICK_ACTION_MOOCH 0
#define CFG_BOOK_LISTVIEW_DOUBLECLICK_ACTION_SHOW_BOOK_INFO 1
#define CFG_BOOK_LISTVIEW_DOUBLECLICK_ACTION_ADD_TO_WISHLIST 2
#define CFG_BOOK_LISTVIEW_DOUBLECLICK_ACTION_SAVE_FOR_LATER 3
#define CFG_BOOK_LISTVIEW_DOUBLECLICK_ACTION_SEARCH_ANOBII 4
#define CFG_BOOK_LISTVIEW_DOUBLECLICK_ACTION_SEARCH_ANOBII_BY_ISBN 5


// Parametro di configurazione: intero con il numero massimo di elementi nella lista dei libri (se <= 0 viene ignorato)
#define CFG_BOOK_LIST_MAX_ITEMS "booklist_max_items"
#define CFG_BOOK_LIST_MIN_ITEMS_COUNT 1
#define CFG_BOOK_LIST_MAX_ITEMS_COUNT 1500

// Paremetro di configurazione: intero con l'età massima in giorni di un libro (se <= 0 vale come ignorato)
#define CFG_BOOK_LIST_MAX_BOOK_AGE "booklist_book_max_age"
#define CFG_BOOK_LIST_MAX_BOOK_AGE_MIN 1
#define CFG_BOOK_LIST_MAX_BOOK_AGE_MAX 15


// Nomi base dei file
#define CFG_LAST_FEED_FILENAME "last_feed.xml"
#define CFG_BOOK_LIST_FILENAME "book_list.xml"
#define CFG_NOTES_FILENAME "notes.txt"

// Url del feed dei nuovi libri: si può aggiungere "&since=NNN", NNN timestamp della data da cui eseguire il fetch
#define CFG_BOOKMOOCH_API_RECENT_URL "http://api.bookmooch.com/api/recent?o=xml&inc=id+added_when+added_by+added_where+Author+Title+ISBN"

// Url per il mooch di un libro: bisogna aggiungere "?asin=NNNN", NNN asin del libro
#define CFG_BOOKMOOCH_API_MOOCH_CHOICE_URL "http://bookmooch.com/m/mooch_choice"

// Url per aggiungi alla wishlist, bisogna agigungere "&asin=NNN", NNN asin del libro
#define CFG_BOOKMOOCH_API_WISHLIST_ADD_URL "http://bookmooch.com/m/wishlist_add?store=amazon.com"

// Url per aggiungi alla lista "salva per dopo", bisogna agigungere "&asin=NNN", NNN asin del libro
#define CFG_BOOKMOOCH_API_SAVE_FOR_LATER_ADD_URL "http://bookmooch.com/m/savelater_add?store=amazon.com"

// Url per l'api sulle informazioni di un libro: aggiungere "?asins=NNN+MMM+...+KKK"
#define CFG_BOOKMOOCH_API_BOOK_INFO_BY_ASINS "http://api.bookmooch.com/api/asin"

// Url per la ricerca su anobii, aggiungere "&keyword=KKK" KKK=stringa codificata per le url
#define CFG_ANOBII_SEARCH_URL "http://www.anobii.com/search?s=1&productType=0"

// Url per la ricerca per ISBN su anobii, aggiungere "&isbn=NNN" NNN=stringa con l'isbn
#define CFG_ANOBII_SEARCH_BY_ISBN_URL "http://www.anobii.com/search?s=1&productType=0&searchAdvance=Cerca"

// Modalità di ricerca su anobii
#define CFG_ANOBII_SEARCH_MODE "anobii_search_mode"
// Ricera su anobii per titolo
#define CFG_ANOBII_SEARCH_BY_TITLE 1
// Ricerca su anobii per ISBN
#define CFG_ANOBII_SEARCH_BY_ISBN 2

// ------------- Valori di default
// Intervallo di fetch di default: 10 minuti
#define CFG_DEFAULT_FETCH_INTERVAL 10
// Intervallo di fetch mininmo
#define CFG_MIN_FETCH_INTERVAL 5
// Intervallo di fetch massimo
#define CFG_MAX_FETCH_INTERVAL 180
// Numero massimo di elementi mostrati
#define CFG_DEFAULT_MAX_BOOK_LIST_ITEMS 500
// Gli elementi più vecchi di X giorni vengono eliminati
#define CFG_DEFAULT_MAX_BOOK_AGE 7

// Ricerca su anobii per titolo
#define CFG_DEFAULT_ANOBII_SEARCH_MODE 1


#endif // DEFINES_H
